Index: GTP/trunk/Lib/Vis/Preprocessing/src/QtInterface/QtGlRenderer.cpp
===================================================================
--- GTP/trunk/Lib/Vis/Preprocessing/src/QtInterface/QtGlRenderer.cpp	(revision 2564)
+++ GTP/trunk/Lib/Vis/Preprocessing/src/QtInterface/QtGlRenderer.cpp	(revision 2565)
@@ -1275,28 +1275,29 @@
             ViewCell *vc = viewcells[i];
 			
-			//cout << "dist: " << vc->GetDistance() << " ";
+			float importance;
 
 			if (mShowPiercingRays)
 			{
-				// const float importance = 5.0f*mTransferFunction * ((float)vc->GetPvs().CountObjectsInPvs() / (float)maxPvs);
-				const float importance = 5.0f * mTransferFunction *
+				// importance = 5.0f*mTransferFunction * ((float)vc->GetPvs().CountObjectsInPvs() / (float)maxPvs);
+				importance = mTransferFunction *
 					((float)vc->GetNumPiercingRays() / (float)maxPiercingRays);
-				// c = RgbColor(importance, 1.0f - importance, 0.0f);
-				c = RainbowColorMapping(importance);
 			}
 			else
 			{
-				// const float importance = 5.0f*mTransferFunction * ((float)vc->GetPvs().CountObjectsInPvs() / (float)maxPvs);
-				const float importance = 5.0f * mTransferFunction *
+				//importance = 5.0f*mTransferFunction * ((float)vc->GetPvs().CountObjectsInPvs() / (float)maxPvs);
+				importance = mTransferFunction *
 					((float)vc->GetPvs().GetSize() / (float)maxPvs);
 				// c = RgbColor(importance, 1.0f - importance, 0.0f);
-				c = RainbowColorMapping(importance);
+				c = RainbowColorMapping(5.0f * importance);
 			}
-			
+
+			// c = RgbColor(importance, 1.0f - importance, 0.0f);
+			c = RainbowColorMapping(5.0f * importance);
+
 			glColor4f(c.r, c.g, c.b, 1.0f - mTransparency);
-			
-			if (!mHideByCost || (mHidingCost < vc->GetNumPiercingRays() / (float)maxPiercingRays)) 
+
+			if (!mHideByCost || (mHidingCost < importance)) 
 			{
-                RenderViewCell(vc);
+				RenderViewCell(vc);
 			}
 		}
@@ -1433,8 +1434,9 @@
 	connect(cb, SIGNAL(toggled(bool)), SIGNAL(SetShowRenderCost(bool)));
 
-	cb = new QCheckBox("Show render cost", hbox);
+	/*cb = new QCheckBox("Show render cost", hbox);
 	hlayout->addWidget(cb);
 	cb->setChecked(false);
 	connect(cb, SIGNAL(toggled(bool)), SIGNAL(SetShowPvsSizes(bool)));
+	*/
 
 	cb = new QCheckBox("Show rays", hbox);
@@ -1443,33 +1445,43 @@
 	connect(cb, SIGNAL(toggled(bool)), SIGNAL(SetShowRays(bool)));
 
-	cb = new QCheckBox("Show piercing rays", hbox);
+	/*cb = new QCheckBox("Show piercing rays", hbox);
 	hlayout->addWidget(cb);
 	cb->setChecked(false);
 	connect(cb, SIGNAL(toggled(bool)), SIGNAL(SetShowPiercingRays(bool)));
-
-
-	QButtonGroup *qbuttongroup = new QButtonGroup(hbox);//, "RenderingGroupBox");
-	//qbuttongroup->setTitle(i18n("Rendering options2"));
-	//qbuttongroup->setColumnLayout(0, Qt::Horizontal);
-	//qbuttongroup->layout()->setSpacing(0);
-	//qbuttongroup->layout()->setMargin(0);
-
-	// Create a layout to organize the widgets.
-	/*QVBoxLayout *qvboxlayout = new QVBoxLayout;//->layout());
-	qvboxlayout->setAlignment(Qt::AlignTop);
-	qvboxlayout->setSpacing(6);
-	qvboxlayout->setMargin(11);
-*/
-	QRadioButton *rb;
+	*/
+
+
+	QRadioButton *rb1, *rb2, *rb3;
 
 	// Create a check box to be in the group box
 	
-	rb = new QRadioButton("piercing rays", hbox);
-	rb->setText("piercing rays");
-	vl->addWidget(rb);
-	
-	rb = new QRadioButton("render cost", hbox);
-	rb->setText("render cost");
-	vl->addWidget(rb);
+	rb1 = new QRadioButton("piercing rays", hbox);
+	rb1->setText("piercing rays");
+	//vl->addWidget(rb1);
+	connect(rb1, SIGNAL(toggled(bool)), SIGNAL(SetShowPiercingRays(bool)));
+
+	rb2 = new QRadioButton("render cost", hbox);
+	rb2->setText("render cost");
+	//vl->addWidget(rb2);
+	connect(rb2, SIGNAL(toggled(bool)), SIGNAL(SetShowPvsSizes(bool)));
+
+	rb3 = new QRadioButton("wireframe", hbox);
+	rb3->setText("wireframe");
+	//vl->addWidget(rb2);
+	//connect(rb2, SIGNAL(toggled(bool)), SIGNAL(SetShowPvsSizes(bool)));
+
+	QGroupBox *groupBox = new QGroupBox("Visualization options");
+
+	QVBoxLayout *vbox2 = new QVBoxLayout;
+    
+	vbox2->addWidget(rb3);
+	vbox2->addWidget(rb1);
+	vbox2->addWidget(rb2);
+	rb2->setChecked(true);
+
+	vbox2->addStretch(1);
+	groupBox->setLayout(vbox2);
+
+	vl->addWidget(groupBox, 0, 0);
 
 	//////////////////////////////////