Index: GTP/trunk/Lib/Vis/Preprocessing/scripts/run_demo_vienna
===================================================================
--- GTP/trunk/Lib/Vis/Preprocessing/scripts/run_demo_vienna	(revision 2571)
+++ GTP/trunk/Lib/Vis/Preprocessing/scripts/run_demo_vienna	(revision 2572)
@@ -19,8 +19,8 @@
 #PREFIX=../work/plots/atlanta2-rss9
 
-#-rss_distributions=mutation+object_direction+spatial \
+
 
 $COMMAND -preprocessor=combined -scene_filename=$SCENE -view_cells_filename=$VIEWCELLS \
--rss_distributions=object_direction \
+-rss_distributions=mutation+object_direction+spatial \ \
 -view_cells_use_kd_pvs+ -af_use_kd_pvs+ \
 -preprocessor_visibility_file=$PREFIX-i-mixed-b1-n4a.xml \
Index: GTP/trunk/Lib/Vis/Preprocessing/scripts/run_demo_arena
===================================================================
--- GTP/trunk/Lib/Vis/Preprocessing/scripts/run_demo_arena	(revision 2571)
+++ GTP/trunk/Lib/Vis/Preprocessing/scripts/run_demo_arena	(revision 2572)
@@ -10,6 +10,4 @@
 PREFIX=../work/plots/osp-TEST
 
-#-rss_distributions=mutation+object_direction+spatial \
-
 $COMMAND -preprocessor=combined -scene_filename=$SCENE -view_cells_filename=$VIEWCELLS \
 -rss_distributions=mutation+object_direction+spatial \
Index: GTP/trunk/Lib/Vis/Preprocessing/src/Preprocessor.cpp
===================================================================
--- GTP/trunk/Lib/Vis/Preprocessing/src/Preprocessor.cpp	(revision 2559)
+++ GTP/trunk/Lib/Vis/Preprocessing/src/Preprocessor.cpp	(revision 2572)
@@ -200,8 +200,10 @@
 	inStream.read(reinterpret_cast<char *>(&numTriangles), sizeof(int));
 	root->mGeometry.reserve(numTriangles);
-	cout << "loading " << numTriangles << " triangles (" 
-		 << numTriangles * (sizeof(TriangleIntersectable) + sizeof(TriangleIntersectable *)) / (1024 * 1024) << " MB)" << endl;
+	cout << "loading " << numTriangles << " triangles (" << numTriangles * 
+		(sizeof(TriangleIntersectable) + sizeof(TriangleIntersectable *)) /
+		(1024 * 1024) << " MB)" << endl;
 
 	int i = 0;
+
 	while (1)
 	{
Index: GTP/trunk/Lib/Vis/Preprocessing/src/QtInterface/QtGlRenderer.cpp
===================================================================
--- GTP/trunk/Lib/Vis/Preprocessing/src/QtInterface/QtGlRenderer.cpp	(revision 2571)
+++ GTP/trunk/Lib/Vis/Preprocessing/src/QtInterface/QtGlRenderer.cpp	(revision 2572)
@@ -720,7 +720,5 @@
 
 	RenderInfo();
-
 	mFrame ++;
-
 }
 
Index: GTP/trunk/Lib/Vis/Preprocessing/src/GlRenderer.cpp
===================================================================
--- GTP/trunk/Lib/Vis/Preprocessing/src/GlRenderer.cpp	(revision 2571)
+++ GTP/trunk/Lib/Vis/Preprocessing/src/GlRenderer.cpp	(revision 2572)
@@ -325,34 +325,33 @@
 }
 	
-void
-GlRenderer::InitGL()
-{
-  mSphere = (GLUquadric *)gluNewQuadric();
-  
-  glMatrixMode(GL_PROJECTION);
-  glLoadIdentity();
-  
-  glMatrixMode(GL_MODELVIEW);
-  glLoadIdentity();
-
-  glFrontFace(GL_CCW);
-  glCullFace(GL_BACK);
-
-  glShadeModel(GL_FLAT);
-  glDepthFunc(GL_LESS );
-  glEnable(GL_DEPTH_TEST);
-  glEnable(GL_CULL_FACE);
-  
-  InitExtensions();
-
-  glTexEnvi(GL_TEXTURE_ENV, GL_TEXTURE_ENV_MODE, GL_REPLACE);
-
-  glEnable(GL_NORMALIZE);
-  
-  glClearColor(0.0f, 0.0f, 1.0f, 1.0f);
-  
-  OcclusionQuery::GenQueries(mOcclusionQueries, 10);
-
-  CreateVertexArrays();
+void GlRenderer::InitGL()
+{
+	mSphere = (GLUquadric *)gluNewQuadric();
+
+	glMatrixMode(GL_PROJECTION);
+	glLoadIdentity();
+
+	glMatrixMode(GL_MODELVIEW);
+	glLoadIdentity();
+
+	glFrontFace(GL_CCW);
+	glCullFace(GL_BACK);
+
+	glShadeModel(GL_FLAT);
+	glDepthFunc(GL_LESS );
+	glEnable(GL_DEPTH_TEST);
+	glEnable(GL_CULL_FACE);
+
+	InitExtensions();
+
+	glTexEnvi(GL_TEXTURE_ENV, GL_TEXTURE_ENV_MODE, GL_REPLACE);
+
+	glEnable(GL_NORMALIZE);
+
+	glClearColor(0.0f, 0.0f, 1.0f, 1.0f);
+
+	OcclusionQuery::GenQueries(mOcclusionQueries, 10);
+
+	CreateVertexArrays();
 }
 
Index: GTP/trunk/Lib/Vis/Preprocessing/src/IntelRayCaster.cpp
===================================================================
--- GTP/trunk/Lib/Vis/Preprocessing/src/IntelRayCaster.cpp	(revision 2187)
+++ GTP/trunk/Lib/Vis/Preprocessing/src/IntelRayCaster.cpp	(revision 2572)
@@ -13,10 +13,34 @@
 
 
+FILE *fileOut = 0;
+bool saveRays = true;
+int cntSavedRaysFLUSH = 0;
+unsigned long int cntSavedRays = 0;
+const intSavedLIMIT = 1024;
+void
+InitSaving()
+{
+  fileOut = fopen("fileRays.txt", "wb");
+  if (!fileOut) {
+    cout << "ERROR: file fileRays.txt cannot be opened .. exiting" << endl;
+    exit(3);
+  }
+}
+void
+FinishSaving()
+{
+  fclose(fileOut);
+}
+
+  
+
 IntelRayCaster::IntelRayCaster(const Preprocessor &preprocessor, 
-							   const string externKdTree):
+			       const string externKdTree):
 RayCaster(preprocessor)
 {
-	if (!InitRayCast(externKdTree))
-		cout << "warning: intel ray tracer could not be initialized!" << endl;
+  if (!InitRayCast(externKdTree))
+    cout << "warning: intel ray tracer could not be initialized!" << endl;
+  if (saveRays)
+    InitSaving();
 }
 
@@ -24,4 +48,6 @@
 IntelRayCaster::~IntelRayCaster()
 {
+  if (saveRays)
+    FinishSaving();
 }
 
@@ -29,101 +55,141 @@
 bool IntelRayCaster::InitRayCast(const string externKdTree)
 {
-	cout<<"Intel ray cast file: " << externKdTree << endl;
+  cout<<"Intel ray cast file: " << externKdTree << endl;
 	
-	return mlrtaLoadAS(externKdTree.c_str());
+  return mlrtaLoadAS(externKdTree.c_str());
 }
 
 
 int IntelRayCaster::CastRay(
-							const SimpleRay &simpleRay,
-							VssRayContainer &vssRays,
-							const AxisAlignedBox3 &box,
-							const bool castDoubleRay,
-							const bool pruneInvalidRays
-							)
-{
-	//cout << "intel ray" << endl;
-	VssRay *vssRay  = NULL;
-	int hits = 0;
-	int hittriangle;
-	Intersection hitA(simpleRay.mOrigin), hitB(simpleRay.mOrigin);
-
-	float dist;
-	double normal[3];
-
-	hittriangle = mlrtaIntersectAS(
-								   &simpleRay.mOrigin.x,
-								   &simpleRay.mDirection.x,
-								   normal,
-								   dist);
-	
-	if (hittriangle != -1 ) {
-		Intersectable *intersect = mPreprocessor.GetParentObject(hittriangle);
+			    const SimpleRay &simpleRay,
+			    VssRayContainer &vssRays,
+			    const AxisAlignedBox3 &box,
+			    const bool castDoubleRay,
+			    const bool pruneInvalidRays
+			    )
+{  
+  //cout << "intel ray" << endl;
+  VssRay *vssRay  = NULL;
+  int hits = 0;
+  int hittriangle;
+  Intersection hitA(simpleRay.mOrigin), hitB(simpleRay.mOrigin);
+  
+  float dist;
+  float dist1, dist2;
+  double normal[3];
+  
+  hittriangle = mlrtaIntersectAS(
+				 &simpleRay.mOrigin.x,
+				 &simpleRay.mDirection.x,
+				 normal,
+				 dist);
+  dist1 = dist;
+  
+  if (hittriangle != -1 ) {
+    Intersectable *intersect = mPreprocessor.GetParentObject(hittriangle);
+    
+    if (intersect)
+    {
+      hitA.mObject = intersect;
+      hitA.mNormal = Vector3(normal[0], normal[1], normal[2]);
+      // Get the normal of that face
+      //		Mesh *mesh = ((MeshInstance *)objectA)->GetMesh();
+      //		normalA = mesh->GetFacePlane(mFaceParents[forward_hit_triangles[i]].mFaceIndex).mNormal;
+      //-rays[index+i].mDirection; // $$ temporary
+      hitA.mPoint = simpleRay.Extrap(dist);
+    }
+  }
+  
+  if (castDoubleRay)
+  {
+    Vector3 dir = -simpleRay.mDirection;
+    hittriangle = mlrtaIntersectAS(
+				   &simpleRay.mOrigin.x,
+				   &dir.x,
+				   normal,
+				   dist);
+    dist2 = dist;
+
+    Intersectable *intersect = mPreprocessor.GetParentObject(hittriangle);
 		
-		if (intersect)
-		{
-			hitA.mObject = intersect;
-			hitA.mNormal = Vector3(normal[0], normal[1], normal[2]);
-			// Get the normal of that face
-			//		Mesh *mesh = ((MeshInstance *)objectA)->GetMesh();
-			//		normalA = mesh->GetFacePlane(mFaceParents[forward_hit_triangles[i]].mFaceIndex).mNormal;
-			//-rays[index+i].mDirection; // $$ temporary
-			hitA.mPoint = simpleRay.Extrap(dist);
-		}
+    if (intersect)
+    {
+      hitB.mObject = intersect;
+      hitB.mNormal = Vector3(normal[0], normal[1], normal[2]);
+      // Get the normal of that face
+      //		Mesh *mesh = ((MeshInstance *)objectB)->GetMesh();
+      //		normalA = mesh->GetFacePlane(mFaceParents[forward_hit_triangles[i]].mFaceIndex).mNormal;
+      //-rays[index+i].mDirection; // $$ temporary
+      hitB.mPoint = simpleRay.Extrap(dist);
+    }
+  }
+
+  if (saveRays) {    
+    if (castDoubleRay)
+	{
+      fprintf(fileOut, "D %d %4.7f %4.7f %4.7f %4.7f %4.7f %4.7f %d %4.7f %d %4.7f\n",
+	      cntSavedRays,
+	      simpleRay.mOrigin.x,
+	      simpleRay.mOrigin.y,
+	      simpleRay.mOrigin.z,
+	      simpleRay.mDirection.x,
+	      simpleRay.mDirection.y,
+	      simpleRay.mDirection.z,
+	      hitA.mObject ? 1 : 0,
+	      hitA.mObject ? dist1 : 0,
+	      hitB.mObject ? 1 : 0,
+	      hitB.mObject ? dist2 : 0
+	      );
 	}
-
-	if (castDoubleRay)
-	{
-		Vector3 dir = -simpleRay.mDirection;
-		hittriangle = mlrtaIntersectAS(
-										&simpleRay.mOrigin.x,
-										&dir.x,
-										normal,
-										dist);
-
-		Intersectable *intersect = mPreprocessor.GetParentObject(hittriangle);
-		
-		if (intersect)
-		{
-			hitB.mObject = intersect;
-			hitB.mNormal = Vector3(normal[0], normal[1], normal[2]);
-			// Get the normal of that face
-			//		Mesh *mesh = ((MeshInstance *)objectB)->GetMesh();
-			//		normalA = mesh->GetFacePlane(mFaceParents[forward_hit_triangles[i]].mFaceIndex).mNormal;
-			//-rays[index+i].mDirection; // $$ temporary
-			hitB.mPoint = simpleRay.Extrap(dist);
-		}
-	}
-
-	return ProcessRay(
-					  simpleRay,
-					  hitA,
-					  hitB,
-					  vssRays,
-					  box,
-					  castDoubleRay,
-					  pruneInvalidRays
-					  );
-}
-
+    else
+      fprintf(fileOut, "S %d %4.7f %4.7f %4.7f %4.7f %4.7f %4.7f %d %4.7f\n",
+	      cntSavedRays,
+	      simpleRay.mOrigin.x,
+	      simpleRay.mOrigin.y,
+	      simpleRay.mOrigin.z,
+	      simpleRay.mDirection.x,
+	      simpleRay.mDirection.y,
+	      simpleRay.mDirection.z,
+	      hitA.mObject ? 1 : 0,
+	      hitA.mObject ? dist1 : 0
+	      );
+    cntSavedRays++;
+    cntSavedRaysFLUSH++;
+    if (cntSavedRaysFLUSH > intSavedLIMIT) {
+      fflush(fileOut);
+      cntSavedRaysFLUSH = 0;
+    }
+  }      
+  
+  return ProcessRay(
+		    simpleRay,
+		    hitA,
+		    hitB,
+		    vssRays,
+		    box,
+		    castDoubleRay,
+		    pruneInvalidRays
+		    );
+}
+  
 
 void IntelRayCaster::CastRays16(
-								SimpleRayContainer &rays,
-								VssRayContainer &vssRays,
-								const AxisAlignedBox3 &sbox,
-								const bool castDoubleRay,
-								const bool pruneInvalidRays)
-{
-	CastRays16(rays, 0, vssRays, sbox, castDoubleRay, pruneInvalidRays);
-}
-
+				SimpleRayContainer &rays,
+				VssRayContainer &vssRays,
+				const AxisAlignedBox3 &sbox,
+				const bool castDoubleRay,
+				const bool pruneInvalidRays)
+{
+  CastRays16(rays, 0, vssRays, sbox, castDoubleRay, pruneInvalidRays);
+}
+  
 void IntelRayCaster::CastRays16(
-								SimpleRayContainer &rays,
-								const int offset,
-								VssRayContainer &vssRays,
-								const AxisAlignedBox3 &sbox,
-								const bool castDoubleRay,
-								const bool pruneInvalidRays)
-{
+				SimpleRayContainer &rays,
+				const int offset,
+				VssRayContainer &vssRays,
+				const AxisAlignedBox3 &sbox,
+				const bool castDoubleRay,
+				const bool pruneInvalidRays)
+{  
   int i, k;
   const int num = 16;
@@ -147,11 +213,11 @@
   for (k=offset, i=0; i < num; i++, k++) {
 #if DEBUG_RAYCAST
-	if (counter == 43964) {
-	  Debug<<rays[k].mOrigin<<" "<<rays[k].mDirection<<endl;
-	}
-#endif
-	mlrtaStoreRayAS16(&rays[k].mOrigin.x,
-					  &rays[k].mDirection.x,
-					  i);
+    if (counter == 43964) {
+      Debug<<rays[k].mOrigin<<" "<<rays[k].mDirection<<endl;
+    }
+#endif
+    mlrtaStoreRayAS16(&rays[k].mOrigin.x,
+		      &rays[k].mDirection.x,
+		      i);
   }
   
@@ -161,7 +227,7 @@
   
   mlrtaTraverseGroupAS16(&min.x,
-						 &max.x,
-						 forward_hit_triangles,
-						 forward_dist);
+			 &max.x,
+			 forward_hit_triangles,
+			 forward_dist);
   
 #if DEBUG_RAYCAST
@@ -170,81 +236,130 @@
 
   if (castDoubleRay) {
-	for (k=offset, i=0; i < num; i++, k++)  {
-	  Vector3 dir = -rays[k].mDirection;
-	  mlrtaStoreRayAS16(&rays[k].mOrigin.x,
-						&dir.x,
-						i);
-	}
+    for (k=offset, i=0; i < num; i++, k++)  {
+      Vector3 dir = -rays[k].mDirection;
+      mlrtaStoreRayAS16(&rays[k].mOrigin.x,
+			&dir.x,
+			i);
+    }
+    
+#if DEBUG_RAYCAST
+    Debug<<"TB\n"<<flush;
+#endif
+    
+    mlrtaTraverseGroupAS16(&min.x,
+			   &max.x,
+			   backward_hit_triangles,
+			   backward_dist);
+  }
 	
 #if DEBUG_RAYCAST
-	  Debug<<"TB\n"<<flush;
-#endif
-	  
-	  mlrtaTraverseGroupAS16(&min.x,
-							 &max.x,
-							 backward_hit_triangles,
-							 backward_dist);
-	}
+  Debug<<"BBB\n"<<flush;
+#endif
+
+  if (saveRays) {
+    if (castDoubleRay)
+      fprintf(fileOut, "G\n");
+    else
+      fprintf(fileOut, "H\n");
+  }
+  
+  for (i=0, k=offset; i < num; i++, k++) 
+  {
+    Intersection hitA(rays[k].mOrigin), hitB(rays[k].mOrigin);
+
+#if DEBUG_RAYCAST
+    Debug<<"FH\n"<<flush;
+#endif
+
+    Intersectable *intersect =
+      mPreprocessor.GetParentObject(forward_hit_triangles[i]);
+
+    if (intersect)
+    {
+      hitA.mObject = intersect;
+      // Get the normal of that face
+      hitA.mNormal = mPreprocessor.GetParentNormal(forward_hit_triangles[i]);
+      
+      //-rays[index+i].mDirection; // $$ temporary
+      hitA.mPoint = rays[k].Extrap(forward_dist[i]);
+    }
+    
+#if DEBUG_RAYCAST
+    Debug<<"BH\n"<<flush;
+#endif
+
+    if (castDoubleRay) 
+    {
+      Intersectable *intersect =
+	mPreprocessor.GetParentObject(backward_hit_triangles[i]);
+      
+      if (intersect)
+      { 
+	hitB.mObject = intersect;
+	hitB.mNormal = mPreprocessor.GetParentNormal(backward_hit_triangles[i]);
 	
-#if DEBUG_RAYCAST
-	Debug<<"BBB\n"<<flush;
-#endif
-	
-	for (i=0, k=offset; i < num; i++, k++) 
-	{
-		Intersection hitA(rays[k].mOrigin), hitB(rays[k].mOrigin);
-
-#if DEBUG_RAYCAST
-		Debug<<"FH\n"<<flush;
-#endif
-
-		Intersectable *intersect = mPreprocessor.GetParentObject(forward_hit_triangles[i]);
-
-		if (intersect)
-		{
-			hitA.mObject = intersect;
-			// Get the normal of that face
-			hitA.mNormal = mPreprocessor.GetParentNormal(forward_hit_triangles[i]);
-
-			//-rays[index+i].mDirection; // $$ temporary
-			hitA.mPoint = rays[k].Extrap(forward_dist[i]);
-		}
-	
-#if DEBUG_RAYCAST
-		Debug<<"BH\n"<<flush;
-#endif
-
-		if (castDoubleRay) 
-		{
-			Intersectable *intersect = mPreprocessor.GetParentObject(backward_hit_triangles[i]);
-
-			if (intersect)
-			{ 
-				hitB.mObject = intersect;
-				hitB.mNormal = mPreprocessor.GetParentNormal(backward_hit_triangles[i]);
-
-				// normalB = rays[i].mDirection; // $$ temporary
-				hitB.mPoint = rays[k].Extrap(-backward_dist[i]);
-			}
-		}
-
-#if DEBUG_RAYCAST
-		Debug<<"PR\n"<<flush;
+	// normalB = rays[i].mDirection; // $$ temporary
+	hitB.mPoint = rays[k].Extrap(-backward_dist[i]);
+      }
+    }
+
+
+    if (saveRays) {
+      if (castDoubleRay)     
+	fprintf(fileOut, "%d %4.7f %4.7f %4.7f %4.7f %4.7f %4.7f %d %4.7f %d %4.7f\n",
+		cntSavedRays,
+		rays[k].mOrigin.x,
+		rays[k].mOrigin.y,
+		rays[k].mOrigin.z,
+		rays[k].mDirection.x,
+		rays[k].mDirection.y,
+		rays[k].mDirection.z,
+		hitA.mObject ? 1 : 0,
+		hitA.mObject ? forward_dist[i] : 0,
+		hitB.mObject ? 1 : 0,
+		hitB.mObject ? -backward_dist[i] : 0
+		);
+      else
+	fprintf(fileOut, "%d %4.7f %4.7f %4.7f %4.7f %4.7f %4.7f %d %4.7f\n",
+		cntSavedRays,
+		rays[k].mOrigin.x,
+		rays[k].mOrigin.y,
+		rays[k].mOrigin.z,
+		rays[k].mDirection.x,
+		rays[k].mDirection.y,
+		rays[k].mDirection.z,
+		hitA.mObject ? 1 : 0,
+		hitA.mObject ? forward_dist[i] : 0
+		);
+      cntSavedRays++;
+      cntSavedRaysFLUSH++;
+    }
+
+    
+#if DEBUG_RAYCAST
+    Debug<<"PR\n"<<flush;
 #endif
 
 #if 1
-		ProcessRay(rays[k],
-				   hitA,
-				   hitB,
-				   vssRays,
-				   sbox,
-				   castDoubleRay,
-				   pruneInvalidRays
-				   );
-#endif
-	}
-
-#if DEBUG_RAYCAST
-	Debug<<"C16F\n"<<flush;
+    ProcessRay(rays[k],
+	       hitA,
+	       hitB,
+	       vssRays,
+	       sbox,
+	       castDoubleRay,
+	       pruneInvalidRays
+	       );
+#endif
+  } // for
+
+  if (saveRays) {
+    if (cntSavedRaysFLUSH > intSavedLIMIT) {
+      fflush(fileOut);
+      cntSavedRaysFLUSH = 0;
+    }
+  }
+
+#if DEBUG_RAYCAST
+  Debug<<"C16F\n"<<flush;
 #endif
 }
@@ -256,7 +371,7 @@
 void
 IntelRayCaster::CastSimpleForwardRays(
-									  SimpleRayContainer &rays,
-									  const AxisAlignedBox3 &sbox
-									  )
+				      SimpleRayContainer &rays,
+				      const AxisAlignedBox3 &sbox
+				      )
 {
   int hit_triangles[16];
@@ -272,15 +387,14 @@
   
   for (i=0; i < packets; i++) {
-	for (j=0; j < 16; j++, k++)
-	  mlrtaStoreRayAS16(&rays[k].mOrigin.x,
-						&rays[k].mDirection.x,
-						j);
-	
-	mlrtaTraverseGroupAS16(&min.x,
-						   &max.x,
-						   hit_triangles,
-						   dist);
-
-  }
+    for (j=0; j < 16; j++, k++)
+      mlrtaStoreRayAS16(&rays[k].mOrigin.x,
+			&rays[k].mDirection.x,
+			j);
+    
+    mlrtaTraverseGroupAS16(&min.x,
+			   &max.x,
+			   hit_triangles,
+			   dist);	
+  } // for
 
 
@@ -288,8 +402,8 @@
 	double normal[3];
 	hit_triangles[0] = mlrtaIntersectAS(
-										&rays[k].mOrigin.x,
-										&rays[k].mDirection.x,
-										normal,
-										dist[0]);
+					    &rays[k].mOrigin.x,
+					    &rays[k].mDirection.x,
+					    normal,
+					    dist[0]);
   }
   
@@ -299,9 +413,9 @@
 void
 IntelRayCaster::CastRays(
-						 SimpleRayContainer &rays,
-						 VssRayContainer &vssRays,
-						 const AxisAlignedBox3 &sbox,
-						 const bool castDoubleRay,
-						 const bool pruneInvalidRays )
+			 SimpleRayContainer &rays,
+			 VssRayContainer &vssRays,
+			 const AxisAlignedBox3 &sbox,
+			 const bool castDoubleRay,
+			 const bool pruneInvalidRays )
 {
 
Index: GTP/trunk/Lib/Vis/Preprocessing/src/UnigraphicsParser.cpp
===================================================================
--- GTP/trunk/Lib/Vis/Preprocessing/src/UnigraphicsParser.cpp	(revision 2176)
+++ GTP/trunk/Lib/Vis/Preprocessing/src/UnigraphicsParser.cpp	(revision 2572)
@@ -69,5 +69,5 @@
   Mesh *currentMesh = MeshManager::GetSingleton()->CreateResource();
 
-  while(fscanf(file,"%s",str)!=EOF) 
+  while(fscanf(file, "%s", str)!=EOF) 
   {
 	  switch (str[0]) 
@@ -118,5 +118,5 @@
 			  vertices.push_back((*c).second);
 
-			  fscanf(file,"%s",str); // get the vertex label
+			  fscanf(file, "%s", str); // get the vertex label
 
 			  while(str[0]!=')') 